
  *   Manix   Atari ST cartridge  version
  

*Rom cartridge

  org $FA0000
 
  dc.l	$abcdef42     *magic
  dc.l	second
  dc.l 	$08000000+autorev    * Bit 27 set
* what means run before Disk-boot

  dc.l	autorev
  dc.w 	%0111101000100100   *time, GEMDOS format, 15 h, 17 min
  dc.w	%0011101011011010  *date - 2009, VI, 26 
  dc.l 	desksw-autorev
  dc.b	 "AUTOMX",0
    even

second
  dc.l 	0    * No more
  dc.l 	$40000000   * TOS app.
  dc.l 	desksw
  dc.w 	%0111101000100100   *time, GEMDOS format
  dc.w 	%0011101011011010 *date - 2009, VI, 26 
  dc.l 	end-desksw
  dc.b	"MANIX.TOS",0
  even


desksw     * Dummy




autorev	

	pea	cheatt(pc)
	move.w	#9,-(sp)
	trap	#1

	clr.w	$600.w


	
*Little pause to see it:
	move.w	#1177,d7

dell1	move.w  #37,-(sp)
	trap  #14
	addq.l  #2,sp

* On key release goes further !
	
	move.b	$FFFFFC02.w,d0

	cmp.b	#$A6,d0    * L released
	beq.s	unlims

	cmp.b	#$94,d0    * T released
	beq.s	unlsT

	cmp.b	#$B0,d0    * B released
	beq.s	unlsB

	cmp.b	#$B1,d0    * N released
	beq.s	toPicsh

wait_k	dbf	d7,dell1
	bra.s	toPicsh

unlsT	st	$601.w
	bra.s	toPicsh
unlsB	st	$601.w
unlims	st	$600.w
	

toPicsh

* Show game's title :

	move.b	#$7,$FFFF8201.w
	move.b	#$80,$FFFF8203.w



	lea 	titp,a3
	lea	$78000,a4
	lea	$7D00(a4),a5
	bsr	depakNRV
	


setpal	moveq	#15,d3
	lea	$FF8240,a2
.pall	move.w	(a5)+,(a2)+
	dbf	d3,.pall


* Copy fade code to place :

	lea	fade(pc),a1
	lea	$72CE6,a2
	moveq	#46,d2
.cf	move.l	(a1)+,(a2)+
	dbf	d2,.cf




	move	#$2700,sr

* timer C off :
	move.b	#$40,$FFFFFA09.w   * Only ACIA enabled


	move.b	#$13,$FFFFFC02.w   * prevent IKBD overflow
	lea	$77FE0,sp


	lea	gamem,a3
	lea	$1000.w,a4    *depack here ... 
	bsr	udp2


* Here fade title pic with original code :
* But needs Vblank enabled

	move.l	#$72CFC,$70.w
	move.w	#$2300,sr
	jsr	$72D28
	move.w	#$2700,sr


ramdpos	equ	$1A00


* Copy code there


	lea	ramdc(pc),a1
	lea	ramdPos.w,a2
	move.w	#199,d2     * 
co2l	move.l	(a1)+,(a2)+
	dbf	d2,co2l


* Floppy access redirect:

	lea	$F9E8,a1
	move.l	(a1),ramdPos+CustD-ramdc
	move.w	#$4EF8,(a1)+
	move.w	#ramdPos,(a1)




* Switch to custom link :

	lea	$7B94.w,a1
	move.w	#$4EF8,(a1)+
	move.w	#ramdPos+SwiC-ramdc,(a1)


* Switch to main link :

	lea	$57F58,a1
	move.w	#$4EF8,(a1)+
	move.w	#ramdPos+SwiM-ramdc,(a1)



	sf	$19FE.w    * Main disk active flag


*Cheat 


	tst.b	$600.w
	beq.s	noUnl
	
	move.b	#$4A,$9A7A   * Lives

noUnl


	tst.b	$601.w
	beq.s	noUnl2
	
	move.b	#$4A,$713C.w    * Time

noUnl2


* Fixing dumb IKBD code :

	move.w	#$6002,$7B98.w    * Skip dumb call when d1 is not set 

	move.w	#$3E7,$7B8E.w   * Just 8 needed once !






rungame	
	jmp	$1000.w




ramdc   * 


 *  from  :   $F9E8

* params :  a0 - dest, d1 - LS , d2 - count  , d3 - R/W flag ????
* image starts at LS=$78 !  

	tst.b	$19FE.w
	bne	CustD

	movem.l	d1-d4/a0-a5,-(sp)
	
contLd	

	

	cmp.w	#$316,d1    * Stupid code calls it before every disk access !
	bne.s	notCat

	move.l	a0,a4
	lea	mikes,a3
	bsr	depakNRV
	bra.s	doneLD


notCat

* Using game's screens as temporary buffer for depacking !

gamscr	equ	$6A000


	ext.l	d1
	ext.l	d2
	sub.w	#$78,d1
	bmi.s	doneLD   *****!!!
	lsl.w	#4,d1
	lsl.l	#5,d1
	lsl.w	#7,d2
	subq.w	#1,d2

	movem.l	d1-d2,-(sp)
	lea	mdld,a3
	lea	gamscr,a4
	bsr	depakNRV
	movem.l	(sp)+,d1-d2
	lea	gamscr,a3
	add.l	d1,a3

.cod	move.l	(a3)+,(a0)+
	dbf	d2,.cod
	
* Clear screen now :

	lea	gamscr,a1
	moveq	#0,d1
	move.w	#3775,d2   * for 60416 bytes
.cls	move.l	d1,(a1)+
	move.l	d1,(a1)+
	move.l	d1,(a1)+
	move.l	d1,(a1)+
	dbf	d2,.cls
	

doneLD	moveq	#0,d0
	movem.l	(sp)+,d1-d4/a0-a5
	rts	


CustD     *  Revert to floppy access 
	dc.l	0  ***
	jmp	$F9EC



SwiC	st	$19FE.w
	jmp	$7B98.w

SwiM	sf	$19FE.w
	jmp	$57F5E




depakNRV	

* a3 - src data pos.
* a4 - dest pos.

* From lower to higher, so  look it by overlap !


* Prepare :

   moveq  #-1,d5    * !
   moveq  #-128,d0
   moveq  #-1,d7
   moveq  #-104,d6   *  ???
   lsl.w  #5,d6

   bra.s   enterD
* 2+2+2+2+2=10


la74   move.b  (a3)+,(a4)+
enterD
la76  add.b  d0,d0    * this is la76 
   bcc.s   la82
   bne.s  la74
la7c  move.b  (a3)+,d0
   addx.b  d0,d0
   bcs.s  la74
la82  moveq  #1,d1
   moveq  #0,d3
la86   add.b  d0,d0
   bne.s  la8e
   move.b (a3)+,d0
   addx.b  d0,d0
la8e  addx.l  d1,d1
   add.b  d0,d0
   bcc.s  la86
   bne.s  la9c
   move.b  (a3)+,d0
   addx.b  d0,d0
   bcc.s  la86

la9c  subq.l  #3,d1
   bcs.s  laaa
   lsl.l  #8,d1
   move.b  (a3)+,d1
   not.l  d1
   beq.s  laf0
   move.l  d1,d5
laaa   add.b  d0,d0
   bne.s  lab2
   move.b  (a3)+,d0
  addx.b  d0,d0
lab2  addx.w  d3,d3
  add.b  d0,d0
   bne.s  labc
   move.b  (a3)+,d0
  addx.b  d0,d0
labc   addx.w  d3,d3
   tst.w  d3
   bne.s  ladc
   addq.w  #1,d3

lac4   add.b  d0,d0
   bne.s  lacc
   move.b  (a3)+,d0
   addx.b  d0,d0
lacc   addx.w  d3,d3
   add.b  d0,d0
   bcc.s  lac4
   bne.s  lada
   move.b  (a3)+,d0
   addx.b  d0,d0
   bcc.s  lac4
lada   addq.w  #2,d3
ladc   lea  0(a4,d5.l),a2
   move.l  d5,d1
   sub.l  d6,d1
   addx.w  d7,d3
   move.b  (a2)+,(a4)+
lae8   move.b  (a2)+,(a4)+
   dbf d3,lae8
   bra.s la76
*20+20+20=60 rows for dcore

laf0   *  done depacking !



   rts

* 126 + 10 = 136 bytes total for NRV2B depacker

	
* End of NRV depak




udp2

* Prepare :  -  not NRV2B !

   moveq  #-1,d5    * !
   moveq  #-128,d0
	moveq	#0,d7
	moveq	#-80,d6
	lsl.w	#4,d6

   bra.s   nrvde+2
* 2+2+2+2+2=10

nrvde	incbin  "UDPO"    * Too lazy to disasm   152 bytes
   rts


fade	incbin    "MXFADE"    * 188 bytes



cheatt      dc.b  27,"H","Press L for unlimited lives",13,10
	dc.b	" T for unlimited time",13,10
	dc.b	" B for both",13,10
    	dc.b  " N for normal play",0
	even




titp    incbin  "MXT"

mikes   incbin  "MIKESD"

mdld   incbin  "MANLD"


gamem    incbin   "MAL"
   
   even




end




